<template>
    <div class="three-column-layout">
      <!-- Left column -->
      <div class="column left-column">
        <!-- Add content for the left column here -->
      </div>
  
      <!-- Middle column -->
      <div class="column middle-column">
        <div v-if="loading">Loading...</div>
        <div v-else>
          <!-- Use the PostList component to display posts within the middle column -->
          <PostList :posts="allPosts" />
        </div>
      </div>
  
      <!-- Right column -->
      <div class="column right-column">
        <!-- Add content for the right column here -->
      </div>
    </div>
  </template>
  
<script>
import PostList from "@/components/blog/PostList";
import { gql } from "graphql-tag";

export default {
name: "AllPosts",
components: {
    PostList,
},
data() {
    return {
    allPosts: [],
    };
},
async created() {
    try {
    const response = await this.$apollo.query({
        query: gql`
        query {
            allPosts {
            title
            subtitle
            publishDate
            published
            metaDescription
            slug
            author {
                user {
                username
                }
            }
            tags {
                name
            }
            likedByUsers {
                user {
                username
                }
            }
            comments {
                text
                user {
                user {
                    username
                }
                }
            }
            }
        }
        `,
    });

    // Handle the case when likedByUsers and comments are null or empty
    this.allPosts = response.data.allPosts.map((post) => {
        return {
        ...post,
        likedByUsersCount: post.likedByUsers || [],
        commentsCount: post.comments || [],
        };
    });

    console.log(this.allPosts);
    } catch (error) {
    console.error("GraphQL Error:", error);
    // Handle the error here if needed
    }
},
};
</script>
  

<style scoped>
.three-column-layout {
  display: flex;
}

.column {
  flex: 1;
  padding: 10px;
  position: relative; /* Add relative positioning for shadows */
}

.column:not(:last-child)::after {
  content: "";
  position: absolute;
  top: 0;
  bottom: 0;
  right: 0;
  width: 1px; /* Adjust the width of the separator line */
  background: linear-gradient(to bottom, rgba(0, 0, 0, 0.15) 0%, transparent 100%); /* 3D shadow effect */
}

/* Adjust flex ratios for the columns */
.left-column {
  flex: 3;
}

.middle-column {
  flex: 6;
}

.right-column {
  flex: 3;
}

.middle-column::after {
  content: none; /* No separator for the middle column */
}

/* Add any other styling for the columns here */

</style>